<style>{% include 'style.css' %}</style>
<div class="form-group" id="kubespawner-profiles-list">
  {%- for profile in profile_list %}
    {#- Wrap everything in a label tag so clicking anywhere selects the option #}
    <label for="profile-item-{{ profile.slug }}"
           class="profile js-profile-label">
      <div class="radio">
        <input type="radio"
               name="profile"
               id="profile-item-{{ profile.slug }}"
               value="{{ profile.slug }}"
               {% if profile.default %}checked{% endif %} />
      </div>
      <div>
        <h3>{{ profile.display_name }}</h3>
        {%- if profile.description %}<p>{{ profile.description }}</p>{%- endif %}
        {%- if profile.profile_options %}
          <div>
            {%- for k, option in profile.profile_options.items() %}
              <div class="js-options-container">
                <div class="option">
                  <label for="profile-option-{{ profile.slug }}--{{ k }}"
                         class="js-profile-option-label">{{ option.display_name }}</label>
                  <select name="profile-option-{{ profile.slug }}--{{ k }}"
                          class="form-control js-profile-option-select">
                    {%- for k, choice in option['choices'].items() %}
                      <option value="{{ k }}" {% if choice.default %}selected{% endif %}{%
                        if choice.disabled %} disabled="true"{% endif %}>{{ choice.display_name }}</option>
                    {%- endfor %}
                    {%- if option['unlisted_choice']['enabled'] %}
                      <option value="unlisted-choice">{{ option['unlisted_choice']['display_name_in_choices'] }}</option>
                    {%- endif %}
                  </select>
                </div>
                {%- if option['unlisted_choice']['enabled'] %}
                  <div class="option hidden js-other-input-container">
                    <label for="profile-option-{{ profile.slug }}--{{ k }}--unlisted-choice">
                      {{ option['unlisted_choice']['display_name'] }}
                    </label>
                    <input data-name="profile-option-{{ profile.slug }}--{{ k }}--unlisted-choice"
                           {%- if option['unlisted_choice']['validation_regex'] %}
                           pattern="{{ option['unlisted_choice']['validation_regex'] }}"
                           {%- endif %}
                           title="{{ option['unlisted_choice']['validation_message'] }}"
                           class="form-control js-other-input" />
                  </div>
                {%- endif %}
              </div>
            {%- endfor %}
          </div>
        {%- endif %}
      </div>
    </label>
  {%- endfor %}
</div>
<script>
  $('.js-profile-option-select, .js-profile-option-label').click(function() {
    // we need this bit of JS to select the profile when a <select> inside is clicked.
    $(this).parents('.js-profile-label')
      .find('input[type=radio]')
      .prop('checked', true);
  });

  // If the user selects "Other" in the dropdown, show the free text field
  $('.js-profile-option-select').change(function() {
    const selectionValue = $(this).val();
    const $otherInputContainer = $(this).parents('.js-options-container').find('.js-other-input-container');
    const $otherInput = $(this).parents('.js-options-container').find('.js-other-input');
    if (selectionValue === 'unlisted-choice') {

      // if the Select box is selected with a value that is not 'unlisted-choice',
      // we remove the "name" attribute for the unlisted-choice input
      // and vice-versa, so that we only submit valid form values
      // and don't leave the complexity of figuring out which value
      // to use to the back-end.

      // This can probably be done cleaner by completely refactoring
      // how we send values from the frontend.
      $(this).data('name', $(this).attr('name'));
      $(this).removeAttr('name');
      $otherInput.attr('name', $otherInput.data('name'));
      $otherInputContainer.removeClass('hidden');
    } else {
      $otherInput.removeAttr('name');
      $(this).attr('name', $(this).data('name'));
      $otherInputContainer.addClass('hidden');
    }
  });

  // wrapping in a document.ready to make clear this is executed once
  // on page load
  $(document).ready(() => {
    // trigger the `change` event on the select inputs,
    // so that if "Other" is selected on page load, the corresponding
    // free-text input shows
    $('.js-profile-option-select').trigger('change');
  });

</script>